---

# ld and ld.gold are both from binutils, while ld.gold only exists if
# you configure with --enable-gold option
# for apt, ld is in binutils pkg, and ld.gold in binutils-gold pkg
# for rpm, ld is in binutils, but no binutils-gold

- name: apt install binutils and binutils-gold
  when: 'ansible_pkg_mgr == "apt"'
  become: yes
  apt:
    update_cache: yes
    name:
      - binutils
      - binutils-gold
  retries: 3
  delay: 60

- name: yum install binutils
  when: 'ansible_pkg_mgr == "yum"'
  become: yes
  yum:
    update_cache: yes
    name:
      - binutils
  retries: 3
  delay: 60

- name: dnf install binutils
  when: 'ansible_pkg_mgr == "dnf"'
  become: yes
  dnf:
    update_cache: yes
    name:
      - binutils
  retries: 3
  delay: 60

- name: get ld path
  command: which ld
  register: which_ld
  failed_when: no

- name: get ld.gold path
  command: which ld.gold
  register: which_ld_gold
  failed_when: no

- name: build binutils for ld and ld.gold if neither exists
  when:
    - 'which_ld.rc != 0'
    - 'which_ld_gold.rc != 0'
  include_role:
    name: xbuild
    vars_from: binutils

- name: link ld to ld.gold if exists
  when: 'which_ld_gold.rc == 0'
  become: yes
  file:
    src: "{{which_ld_gold.stdout}}"
    dest: /usr/bin/ld
    state: link
    force: no  # do not force link
